package com.metro.controller;/*
 * @Description
 * @Date 2022/5/17 10:32
 * @Author wxg
 * */

import com.github.xiaoymin.knife4j.annotations.ApiOperationSupport;
import com.metro.baseRe.BaseResponse;
import com.metro.entity.dto.DataShowMiddlerDTO;
import com.metro.entity.vo.*;
import com.metro.service.DataShowService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;

@RestController
@RequestMapping("/dataShow")
@Api(tags = "A 首页大屏展示")
public class AdminDataShowController extends BaseController {

    @Autowired
    private DataShowService dataShowService;

    @ApiOperation("首页大屏上端的数据")
    @ApiOperationSupport(order = 1)
    @GetMapping("/selectDataShowTop")
    public BaseResponse<DataShowTopVO> selectDataShowTop() {
        return dataShowService.selectDataShowTop();
    }
    @ApiOperation("首页人流量Top20站点")
    @ApiOperationSupport(order = 2)
    @PostMapping("/selectDataShowMiddler")
    public BaseResponse<DataShowMiddleVO> selectDataShowMiddler(@RequestBody DataShowMiddlerDTO dataShowMiddlerDTO) {
        return dataShowService.selectDataShowMiddler(dataShowMiddlerDTO);
    }
    @ApiOperation("站点盘查人流量变化")
    @ApiOperationSupport(order = 3)
    @GetMapping("/selectDataShowMiddlerSite")
    public BaseResponse<DataShowMiddleSiteVO> selectDataShowMiddlerSite(@RequestParam(value = "id",required = false) Integer id) {
        return dataShowService.selectDataShowMiddlerSite(id);
    }
    @ApiOperation("站点盘查人流量变化的站点列表")
    @ApiOperationSupport(order = 3)
    @GetMapping("/selectSiteList")
    public BaseResponse<List<SiteVO>> selectSiteList() {
        return BaseResponse.ok(dataShowService.selectSiteList());
    }
    @ApiOperation("实时预警人员")
    @ApiOperationSupport(order = 4)
    @GetMapping("/selectWarningList")
    public BaseResponse<List<DataShowWarningVO>> selectWarningList() {
        return BaseResponse.ok(dataShowService.selectWarningList());
    }
    @ApiOperation("实时预警详情")
    @ApiOperationSupport(order = 5)
    @GetMapping("/selectWarningDetail")
    public BaseResponse<WarningDetailOneVO> selectWarningDetail(@RequestParam(value = "id",required = true) Integer id) {
        return BaseResponse.ok(dataShowService.selectWarningDetail(id));
    }
}
