package com.metro.controller;

import com.metro.baseRe.BaseResponse;
import com.metro.entity.ro.area.SelectAreaReq;
import com.metro.entity.ro.area.SelectAreaResp;
import com.metro.service.AreaService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.validation.Valid;
import java.util.List;

/**
 * @ClassName: AreaController
 * @Description: TODO
 * @Author: ZS
 * @CreateName: lws
 * @Date 2022/3/10 23:29
 * ...
 */
@RestController
@RequestMapping("/area")
@Api(tags = "地区")
public class AreaController {

    @Autowired
    private AreaService service;

    /**
     * 查询地区联动
     * @param req 查询条件
     * @return 返回结果list
     */
    @ApiOperation("查询地区联动")
    @PostMapping("/selectArea")
    public BaseResponse<List<SelectAreaResp>> selectArea(@Valid @RequestBody SelectAreaReq req) {
        return service.selectArea(req);
    }

}
