package com.metro.controller;

import com.metro.baseRe.BaseResponse;
import com.metro.entity.vo.BranchVO;
import com.metro.entity.vo.CompanyCompanyVO;
import com.metro.entity.vo.CompanyVO;
import com.metro.service.CompanyService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;

/**
 * @ClassName: ConpanysController
 * @Description: TODO
 * @Author: ZS
 * @CreateName: lws
 * @Date 2022/3/8 13:38
 * ...
 */
@RestController
@RequestMapping("/company")
@Api(tags = "地铁地区管理")
public class CompanyController {

    @Autowired
    private CompanyService companyService;

//    /**
//     * 公安查询
//     * @param req 查询条件
//     * @return 返回结果
//     */
//    @PostMapping("/select")
//    @ApiOperation("公安查询")
//    public BaseResponse<List<SelectCompanyPageResp>> selectCompany(@Valid @RequestBody SelectCompanyPageReq req){
//        return BaseResponse.ok(service.page(req));
//    }

    @PostMapping("/getCompanyList")
    @ApiOperation("获取地铁列表")
    public BaseResponse<List<CompanyVO>> getCompanyList(){
        return BaseResponse.ok(companyService.getCompanyList());
    }

    @GetMapping("/getBranchList")
    @ApiOperation("获取地区列表")
    public BaseResponse<List<BranchVO>> getBranchList(@RequestParam("companyId") String companyId){
        return BaseResponse.ok(companyService.getBranchList(companyId));

    }

    @PostMapping("/getAll")
    @ApiOperation("获取地址分级列表")
    public BaseResponse<List<CompanyCompanyVO>> getAll(){
        return BaseResponse.ok(companyService.getAll());
    }
}
