package com.metro.controller;


import com.baomidou.mybatisplus.core.metadata.IPage;
import com.metro.baseRe.BaseResponse;
import com.metro.entity.dto.CourtControlDTO;
import com.metro.entity.search.CourtControlSearch;
import com.metro.entity.vo.CourtControlVO;
import com.metro.security.Authority;
import com.metro.service.CourtControlService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.validation.Valid;

/**
 * <p>
 * 法院协控 前端控制器
 * </p>
 *
 * @author wxg
 * @since 2022-07-19
 */
@RestController
@RequestMapping("/courtControl")
@Api(tags = "B 法院临控管理")
public class CourtControlController {

    @Autowired
    private CourtControlService courtControlService;

    @ApiOperation("法院临控人员查询")
    @PostMapping("/getPageList")
    @Authority
    public BaseResponse<IPage<CourtControlVO>> getPageList(@Valid @RequestBody  CourtControlSearch courtControlSearch) {
        return BaseResponse.ok(courtControlService.getPageList(courtControlSearch));
    }

    @PostMapping("/insertOrUpdate")
    @Authority
    @ApiOperation("添加修改法院临控人员")
    public BaseResponse<Boolean> insertOrUpdate(@Valid @RequestBody CourtControlDTO courtControlDTO) {
        Integer insert = courtControlService.insertOrUpdate(courtControlDTO);
        if(insert == 1){
            return BaseResponse.ok("添加成功");
        }else{
            return BaseResponse.fail("添加失败");
        }
    }

    @GetMapping("/delete")
    @Authority
    @ApiOperation("删除法院临控人员")
    public BaseResponse<Boolean> delete(@RequestParam("sfzh")String sfzh) {
        Integer integer = courtControlService.delete(sfzh);
        if(integer == 1){
            return BaseResponse.ok("添加成功");
        }else{
            return BaseResponse.fail("添加失败");
        }
    }
}
