package com.metro.controller;


import com.metro.baseRe.BaseResponse;
import com.metro.entity.vo.DataDictionaryVO;
import com.metro.security.Authority;
import com.metro.service.DataDictionaryService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;
import java.util.List;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author wxg
 * @since 2022-07-21
 */
@RestController
@Api(tags = "B 数据字典")
@RequestMapping("/dataDictionary")
public class DataDictionaryController {

    @Resource
    private DataDictionaryService dataDictionaryService;

    @GetMapping("/getOrgNameLsit")
    @Authority
    @ApiOperation("获取关注单位列表")
    public BaseResponse<List<DataDictionaryVO>> getOrgNameLsit() {
        return dataDictionaryService.getOrgNameLsit();
    }
}
