package com.metro.controller;


import com.baomidou.mybatisplus.core.metadata.IPage;
import com.metro.baseRe.BaseResponse;
import com.metro.entity.dto.ExecuteControlDTO;
import com.metro.entity.search.ExecuteControlSearch;
import com.metro.entity.vo.ExecuteControlVO;
import com.metro.security.Authority;
import com.metro.service.ExecuteControlService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.validation.Valid;

/**
 * <p>
 * 临时布控 前端控制器
 * </p>
 *
 * @author wxg
 * @since 2022-07-19
 */
@RestController
@RequestMapping("/executeControl")
@Api(tags = "B 临时布控管理")
public class ExecuteControlController {

    @Autowired
    private ExecuteControlService executeControlService;

    @ApiOperation("临时布控人员查询")
    @PostMapping("/getPageList")
    @Authority
    public BaseResponse<IPage<ExecuteControlVO>> getPageList(@Valid @RequestBody ExecuteControlSearch executeControlSearch) {
        return BaseResponse.ok(executeControlService.getPageList(executeControlSearch));
    }

    @PostMapping("/insertOrUpdate")
    @Authority
    @ApiOperation("添加修改临时布控人员")
    public BaseResponse<Boolean> insertOrUpdate(@Valid @RequestBody ExecuteControlDTO executeControlDTO) {
        Integer insert = executeControlService.insertOrUpdate(executeControlDTO);
        if(insert == 1){
            return BaseResponse.ok("添加成功");
        }else{
            return BaseResponse.fail("添加失败");
        }
    }

    @GetMapping("/delete")
    @Authority
    @ApiOperation("删除临时布控人员")
    public BaseResponse<Boolean> delete(@RequestParam("idNum")String idNum) {
        Integer integer = executeControlService.delete(idNum);
        if(integer == 1){
            return BaseResponse.ok("添加成功");
        }else{
            return BaseResponse.fail("添加失败");
        }
    }
}
