package com.metro.controller;


import com.baomidou.mybatisplus.core.metadata.IPage;
import com.metro.baseRe.BaseResponse;
import com.metro.entity.dto.JDeviceUpdateDTO;
import com.metro.entity.search.JDevicesSearch;
import com.metro.entity.vo.JDevicesLessVO;
import com.metro.entity.vo.JDevicesVO;
import com.metro.service.JDevicesService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author wxg
 * @since 2022-04-26
 */
@RestController
@Api(tags = "设备管理")
@RequestMapping("/jDevices")
public class JDevicesController {

    @Autowired
    private JDevicesService jDevicesService;

    @PostMapping("/getPageList")
    @ApiOperation("设备列表查询")
    public BaseResponse<IPage<JDevicesVO>> getPageList(@RequestBody JDevicesSearch jDevicesSearch) {
        return BaseResponse.ok(jDevicesService.getPageList(jDevicesSearch));
    }
    @GetMapping("/getList")
    @ApiOperation("设备列表(id和deviceId)")
    public BaseResponse<List<JDevicesLessVO>> getList() {
        return BaseResponse.ok(jDevicesService.getList());
    }



    @PostMapping("/updateJDevice")
    @ApiOperation("修改设备信息（地铁盘口）")
    public BaseResponse<Boolean> updateJDevice(@RequestBody JDeviceUpdateDTO jDeviceUpdateDTO) {
        return BaseResponse.ok(jDevicesService.updateJDevice(jDeviceUpdateDTO));
    }
}
