package com.metro.controller;

import com.metro.baseRe.BaseResponse;
import com.metro.entity.po.Metro;
import com.metro.entity.ro.metro.SelectMetroParentResp;
import com.metro.entity.ro.metro.SelectMetroReq;
import com.metro.entity.ro.metro.SelectMetroResp;
import com.metro.service.MetroService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.validation.Valid;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.stream.Collectors;

/**
 * @ClassName: 地铁
 * @Description: TODO
 * @Author: ZS
 * @CreateName: lws
 * @Date 2022/3/8 13:38
 * ...
 */
@RestController
@RequestMapping("/metro")
@Api(tags = "地铁")
public class MetroController {

    @Autowired
    private MetroService service;

    /**
     * 地铁查询
     *
     * @param req 查询条件
     * @return 返回结果
     */
    @PostMapping("/select")
    @ApiOperation("地铁查询一二级三级")
    public BaseResponse<List<SelectMetroResp>> selectMetro(@RequestBody @Valid SelectMetroReq req) {
        return BaseResponse.ok(service.list(req));
    }

    @PostMapping("/selectAll")
    @ApiOperation("地铁列表")
    public BaseResponse<List<SelectMetroParentResp>> selectMetroAll() {
        return BaseResponse.ok(service.selectMetroAll());
    }


}
