package com.metro.controller;


import com.github.xiaoymin.knife4j.annotations.ApiOperationSupport;
import com.metro.baseRe.BaseResponse;
import com.metro.entity.dto.DeviceDTO;
import com.metro.service.OpenAPIService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.Map;

/**
 * <p>
 * 战果统计表 前端控制器
 * </p>
 *
 * @author wxg
 * @since 2022-05-19
 */
@RestController
@Api(tags = "对外的api接口")
public class OpenAPIController {

    @Autowired
    private OpenAPIService openAPIService;

    @ApiOperation("验证是否在临控区")
    @ApiOperationSupport(order = 1)
    @GetMapping("/selectByIdNum")
    public BaseResponse<Boolean> selectByIdNum(@RequestParam("idNum")@ApiParam("身份证号") String idNum) {
        return openAPIService.selectByIdNum(idNum);
    }
    @ApiOperation("设备获取信息")
    @ApiOperationSupport(order = 1)
    @PostMapping("/device/getInfo")
    public Map<String,Object> selectByDeviceId(@RequestBody DeviceDTO deviceDTO) {
        return openAPIService.selectByDeviceId(deviceDTO);
    }
}
