package com.metro.controller;


import com.baomidou.mybatisplus.core.metadata.IPage;
import com.github.xiaoymin.knife4j.annotations.ApiOperationSupport;
import com.metro.baseRe.BaseResponse;
import com.metro.entity.search.PoliceSearch;
import com.metro.entity.search.WarFruitSearch;
import com.metro.entity.vo.WarFruitTopVO;
import com.metro.entity.vo.WarFruitVO;
import com.metro.service.WarFruitService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletResponse;
import javax.validation.Valid;

/**
 * <p>
 * 战果统计表 前端控制器
 * </p>
 *
 * @author wxg
 * @since 2022-05-19
 */
@RestController
@Api(tags = "A 战果统计展示")
@RequestMapping("/warFruit")
public class WarFruitController {

    @Autowired
    private WarFruitService warFruitService;

    @ApiOperation("派出所top10")
    @ApiOperationSupport(order = 1)
    @PostMapping("/polliceOfficeTop10")
    public BaseResponse<WarFruitTopVO> polliceOfficeTop10(@RequestBody WarFruitSearch warFruitSearch) {
        return BaseResponse.ok(warFruitService.polliceOfficeTop10(warFruitSearch));
    }
    @ApiOperation("民警top10")
    @ApiOperationSupport(order = 2)
    @PostMapping("/policeTop10")
    public BaseResponse<WarFruitTopVO> policeTop10(@RequestBody WarFruitSearch warFruitSearch) {
        return BaseResponse.ok(warFruitService.policeTop10(warFruitSearch));
    }
    @ApiOperation("民警列表")
    @ApiOperationSupport(order = 3)
    @PostMapping("/policePageList")
    public BaseResponse<IPage<WarFruitVO>> policePageList(@RequestBody PoliceSearch policeSearch) {
        return BaseResponse.ok(warFruitService.policePageList(policeSearch));
    }
    @PostMapping("/excelPolicePageList")
    @ApiOperation("excel导出民警列表")
    public void  excelPolicePageList(@Valid @RequestBody PoliceSearch policeSearch, HttpServletResponse response) {
        warFruitService.excelWarningPageList(policeSearch,response);
    }
    @PostMapping("/excelPoliceStationPageList")
    @ApiOperation("excel导出派出所列表")
    public void  excelPoliceStationPageList(@Valid @RequestBody WarFruitSearch warFruitSearch, HttpServletResponse response) {
        warFruitService.excelPoliceStationPageList(warFruitSearch,response);
    }
}
