package com.metro.entity.error;

import lombok.*;
import lombok.experimental.Accessors;

import java.util.List;
import java.util.Map;

@Data
@AllArgsConstructor
@ToString
@NoArgsConstructor
@Builder
@Accessors(chain = true)
public class CommonRes {

    String msg;
    int code;
    Map<String, Object> result;
    List<Object> lists;

    // 返回默认成功
    public static CommonRes success() {
        return new CommonRes().setCode(200).setMsg("success");
    }
    public static CommonRes success(Map<String, Object> result) {
        return new CommonRes().setCode(200).setMsg("success").setResult(result);
    }
    public static CommonRes error(String errMsg) {
        return new CommonRes().setCode(400).setMsg(errMsg);
    }
    public static CommonRes error(int errCode , String errMsg) {
        return new CommonRes().setCode(errCode).setMsg(errMsg);
    }
}
