package com.metro.entity.excel;

import com.alibaba.excel.annotation.ExcelProperty;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import lombok.Data;

import java.util.Date;

/**
 * @description:
 * @ClassName WarningExcel
 * @Author WXG
 * @Date 2022/7/8 13:46
 */
@ApiModel("预警人员Excel model")
@Data
public class WarningExcel {

    @ExcelProperty(value = "姓名",index = 0)
    private String xm;

    @ExcelProperty(value = "身份证号",index = 1)
    private String cardId;

    @ExcelProperty(value = "手机号",index = 2)
    private String phone;

    @ExcelProperty(value = "所属派出所名",index = 3)
    private String companyName;

    @ExcelProperty(value = "所属派分局名",index = 4)
    private String branchName;

    @ExcelProperty(value = "通行时间",index = 5)
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date passTime;

    @ExcelProperty(value = "处置民警",index = 6)
    private String staffName;

    @ExcelProperty(value = "处置民警账号",index = 7)
    private String staffCardId;

    @ExcelProperty(value = "上一次预警时间",index = 8)
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date lastTime;

    @ExcelProperty(value = "人员类型",index = 9)
    private String kind;
}
