package com.metro.entity.po;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.io.Serializable;
import java.util.Date;

/**
 * <p>
 * 法院协控
 * </p>
 *
 * @author wxg
 * @since 2022-07-19
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@TableName("court_control")
public class CourtControl implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * 身份证号码
     */
    @TableId(value = "sfzh", type = IdType.INPUT)
    private String sfzh;

    /**
     * 姓名
     */
    @TableField("xm")
    private String xm;

    /**
     * 执行依据
     */
    @TableField("zxyj")
    private String zxyj;

    /**
     * 布控法院
     */
    @TableField("bkfy")
    private String bkfy;

    /**
     * 承办人
     */
    @TableField("cbr")
    private String cbr;

    /**
     * 联系电话
     */
    @TableField("lxdh")
    private String lxdh;

    /**
     * 申请日期
     */
    @TableField("sqrq")
    @JsonFormat(pattern="yyyy-MM-dd")
    private Date sqrq;

    /**
     * 失效日期
     */
    @TableField("sxrq")
    @JsonFormat(pattern="yyyy-MM-dd")
    private Date sxrq;

    /**
     * 处置要求
     */
    @TableField("czyq")
    private String czyq;

    /**
     * 简要案情
     */
    @TableField("jyaq")
    private String jyaq;

}
