package com.metro.entity.po;

import com.baomidou.mybatisplus.annotation.*;
import io.swagger.models.auth.In;
import lombok.Data;
import lombok.experimental.Accessors;

import java.time.LocalDateTime;

/**
 * @ClassName: Persons
 * @Description: TODO
 * @Author: ZS
 * @CreateName: lws
 * @Date 2022/3/13 14:20
 * ...
 */
@Data
@TableName("j_account")
@Accessors(chain = true)
public class Police {

    @TableId(value = "id",type = IdType.AUTO)
    private Integer id;

    /**
     * 账号名称
     */
    private String account;

    /**
     * 管理员姓名
     */
    private String userName;

    /**
     * 账号密码
     */
    private String password;

    /**
     * 管理员手机号
     */
    private String phone;

    /**
     * 用户类型 1:管理员 2:派出所 3
     */
    private Integer type;

    /**
     * 地区id
     */
    private Integer areaId;

    /**
     * 详细地址
     */
    private String address;

    /**
     * 警号Id
     */
    private String policeId;

    /**
     * 公安Id
     */
    private String companyId;

    /**
     *分局id
     */
    private String branchId;


    /**
     * 创建时间
     */
    @TableField(value = "create_time", fill = FieldFill.INSERT)
    private LocalDateTime createTime;

    /*
     * 创建人
     * */

    private Integer createId;

    /*
     * 修改时间
     * */
    @TableField(value = "update_time", fill = FieldFill.INSERT_UPDATE)
    private LocalDateTime updateTime;

    /*
     * 修改人
     * */
    private Integer updateId;

    /*
     * 是否删除 true 删除    false 不删除
     * */
    private Boolean isDelete;

    /*
     * 状态  true 正常    false 停用
     * */
    private Boolean status;


}
