package com.metro.entity.po;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.io.Serializable;
import java.util.Date;

/**
 * <p>
 * 战果统计表
 * </p>
 *
 * @author wxg
 * @since 2022-05-19
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@TableName("war_fruit")
public class WarFruit implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * 战果统计表主键id
     */
    @TableId(value = "id", type = IdType.AUTO)
    private Integer id;

    /**
     * 身份证号
     */
    @TableField("card_id")
    private String cardId;

    /**
     * 人数
     */
    @TableField("number")
    private Integer number;
    /**
     * 日期
     */
    @TableField("date")
    private Date date;

    /**
     * 抓捕人数
     */
    @TableField("arrest_number")
    private Integer arrestNumber;

    /**
     * 存疑人数
     */
    @TableField("doubt_number")
    private Integer doubtNumber;

    /**
     * 正常通过人数
     */
    @TableField("pass_number")
    private Integer passNumber;

    /**
     * 异常人数
     */
    @TableField("exception_number")
    private Integer exceptionNumber;
}
