package com.metro.entity.ro.Police;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import javax.validation.constraints.NotEmpty;
import javax.validation.constraints.Size;
import java.io.Serializable;

/**
 * @ClassName: InsertPoliceReq
 * @Description: TODO
 * @Author: ZS
 * @CreateName: lws
 * @Date 2022/3/18 9:33
 * ...
 */
@Data
public class InsertPoliceReq implements Serializable {

    @ApiModelProperty(value = "账号")
    @NotEmpty(message = "账号不能为空")
    private String account;

    @ApiModelProperty(value = "派出所名称")
    private String branchName;

    @NotEmpty(message = "管理员姓名不能为空")
    @ApiModelProperty(value = "管理员姓名")
    private String userName;

    @NotEmpty(message = "派出所管理员手机号不能为空")
    @ApiModelProperty(value = "管理员手机号")
    private String phone;

    @NotEmpty(message = "密码不能为空")
    @ApiModelProperty(value = "密码")
    private String password;

    @ApiModelProperty(value = "用户等级（3：派出所管理员）",hidden = true)
    private Integer type = 3;

    @NotEmpty(message = "详细地址不能为空")
    @ApiModelProperty(value = "详细地址")
    private String address;

    @ApiModelProperty("警号Id")
    private String policeId;

}