package com.metro.entity.ro.account;

import com.metro.enums.UserEnums;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import javax.validation.constraints.NotEmpty;
import java.io.Serializable;
import java.time.LocalDateTime;

/**
 * @ClassName: AccountCompanyPageResp
 * @Description: TODO
 * @Author: ZS
 * @CreateName: lws
 * @Date 2022/3/10 10:14
 * ...
 */
@Data
@ApiModel
public class DetailAccountResp implements Serializable {

    @ApiModelProperty(value = "id")
    private Integer id;

    @ApiModelProperty(value = "账号名称")
    private String account;

    @ApiModelProperty(value = "管理员姓名")
    private String userName;

    @ApiModelProperty(value = "管理员手机号")
    private String phone;

    @ApiModelProperty(value = "地区Id")
    private String areaId;

    @ApiModelProperty(value = "地区中文")
    private String areaDesc;

    @ApiModelProperty(value = "省区id")
    private String provinceId;

    @ApiModelProperty(value = "市区id，")
    private String cityId;

    @ApiModelProperty(value = "用户类行 1admin 2分局管理员 3，")
    private Integer type;

    @ApiModelProperty(value = "详细地址")
    private String address;

    @ApiModelProperty(value = "创建时间")
    private LocalDateTime createTime;

    @ApiModelProperty(value = "创建人")
    private LocalDateTime createId;

    @ApiModelProperty(value = "部门Id")
    private String companyId;

    @ApiModelProperty(value = "派出所Id")
    private String branchId;

    @ApiModelProperty(value = "修改时间")
    private LocalDateTime updateTime;

    @ApiModelProperty(value = "修改人")
    private LocalDateTime updateId;

    @ApiModelProperty(value = "是否删除")
    private boolean isDelete;
    public String getIsDeleteName(){
        return UserEnums.deleteEnums.getStatusName(this.isDelete);
    }

    @ApiModelProperty(value = "账号状态码")
    private boolean status;

    @ApiModelProperty(value = "账号状态")
    private String statusNme;
    public String getStatusName(){
        return UserEnums.statusEnums.getStatusName(this.status);
    }

}
