package com.metro.entity.ro.account;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.metro.enums.UserEnums;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.experimental.Accessors;

import java.io.Serializable;
import java.time.LocalDateTime;

/**
 * @ClassName: AccountCompanyPageResp
 * @Description: TODO
 * @Author: ZS
 * @CreateName: lws
 * @Date 2022/3/10 10:14
 * ...
 */
@Data
@ApiModel
@Accessors(chain = true)
public class SelectAccountPageResp implements Serializable {

    @ApiModelProperty(value = "id")
    private Integer id;

    @ApiModelProperty(value = "账号名称")
    private String account;

    @ApiModelProperty(value = "管理员姓名")
    private String userName;

    @ApiModelProperty(value = "部门Id")
    private String companyId;

    @ApiModelProperty(value = "部门名")
    private String companyName;

    @ApiModelProperty(value = "派出所Id")
    private String branchId;

    @ApiModelProperty(value = "派出所名")
    private String branchName;

    /**
     * 管理员手机号
     */
    @ApiModelProperty(value = "管理员手机号")
    private String phone;

    @ApiModelProperty(value = "地区Id")
    private Integer areaId;

    @ApiModelProperty(value = "地区中文")
    private String areaDesc;


    @ApiModelProperty(value = "详细地址")
    private String address;

    @ApiModelProperty(value = "创建时间")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss")
    private LocalDateTime createTime;

    @ApiModelProperty(value = "创建人")
    private LocalDateTime createId;

    @ApiModelProperty(value = "用户类型 1:admin  2:公安分局管理员  3：派出所管理员  4：民警")
    private Integer type;

    @ApiModelProperty(value = "修改时间")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss")
    private LocalDateTime updateTime;

    @ApiModelProperty(value = "修改人")
    private LocalDateTime updateId;

    @ApiModelProperty(value = "账号状态码")
    private boolean status;

    @ApiModelProperty(value = "警号id")
    private String policeId;

    @ApiModelProperty(value = "照片")
    private String fileName;

    @ApiModelProperty(value = "账号状态")
    private String statusNme;
    public String getStatusName(){
        return UserEnums.statusEnums.getStatusName(this.status);
    }


}
