package com.metro.enums;

import lombok.Data;
import lombok.Getter;
import org.springframework.web.bind.annotation.GetMapping;

import java.io.Serializable;

/**
 * @ClassName: UserEunms
 * @Description: 用户枚举类
 * @Author: ZS
 * @CreateName: lws
 * @Date 2022/3/12 10:56
 * ...
 */
public class UserEnums implements Serializable {

    /**
     * 用户状态枚举
     */
    @Getter
    public enum statusEnums {

        NORMAL(true, "正常"),
        STOP(false, "停用");

        private Boolean status;

        private String statusName;

        statusEnums(Boolean status, String statusName) {
            this.status = status;
            this.statusName = statusName;
        }

        // 获取状态名称
        public static String getStatusName(Boolean status) {
            for (statusEnums c : statusEnums.values()) {
                if (c.getStatus() == status) {
                    return c.getStatusName();
                }
            }
            return "";
        }
    }

    /**
     * 用户状态枚举
     */
    @Getter
    public enum deleteEnums {

        NORMAL(true, "未删除"),
        STOP(false, "删除");

        private Boolean status;

        private String statusName;

        deleteEnums(Boolean status, String statusName) {
            this.status = status;
            this.statusName = statusName;
        }

        // 获取状态名称
        public static String getStatusName(Boolean status) {
            for (statusEnums c : statusEnums.values()) {
                if (c.getStatus() == status) {
                    return c.getStatusName();
                }
            }
            return "";
        }
    }

    /**
     * 用户状态枚举
     */
    @Getter
    public enum passEnums {

        STOP(0, "阻止通行"),
        PASS(1, "可通行"),
        PASS_NO(2, "可通行"),
        ;

        private Integer status;

        private String statusName;

        passEnums(Integer status, String statusName) {
            this.status = status;
            this.statusName = statusName;
        }

        // 获取状态名称
        public static String getStatusName(Integer status) {
            for (passEnums c : passEnums.values()) {
                if (c.getStatus().equals(status)) {
                    return c.getStatusName();
                }
            }
            return "";
        }
    }
}
