package com.metro.enums.vaildated.impl;

import com.metro.enums.vaildated.IsPhone;
import org.apache.commons.lang3.StringUtils;

import javax.validation.ConstraintValidator;
import javax.validation.ConstraintValidatorContext;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

public class IsPhoneImpl implements ConstraintValidator<IsPhone, String> {

    @Override
    public boolean isValid(String value, ConstraintValidatorContext constraintValidatorContext) {
        if(StringUtils.isBlank(value)){
            return true;
        }
        return isPhoneNumberValid(value);
    }

    private boolean isPhoneNumberValid(String phoneNumber){
        phoneNumber = StringUtils.trim(phoneNumber);
        boolean isValid = false;
        String expression = "^((13[0-9])|(15[^4,\\D])|(14[0,1-9])|(18[0,1-9])|(17[0,1-9]))\\d{8}$"
                +"||"+"^\\d{3}-?\\d{3}-?\\d{4}|\\d{3}-?\\d{3}-?\\d{4}&"
                +"||"+"^\\d{4}-?\\d{8}|\\d{4}-?\\d{8}&"
                +"||"+"^\\d{4}-?\\d{7}|\\d{4}-?\\d{7}&"
                +"||"+"^\\d{3}-?\\d{7}|\\d{4}-?\\d{7}&"
                +"||"+"^\\d{3}-?\\d{8}|\\d{4}-?\\d{8}&";
        CharSequence inputStr = phoneNumber;
        Pattern pattern = Pattern.compile(expression);
        Matcher matcher = pattern.matcher(inputStr);
        if (matcher.matches()) {
            isValid = true;
        }
        return isValid;
    }
}
