package com.metro.service;

import com.metro.entity.po.Company;
import com.metro.entity.ro.company.SelectCompanyPageReq;
import com.metro.entity.ro.company.SelectCompanyPageResp;
import com.metro.entity.vo.BranchVO;
import com.metro.entity.vo.CompanyCompanyVO;
import com.metro.entity.vo.CompanyVO;

import java.util.List;
import java.util.Map;
import java.util.function.Function;

/**
 * @ClassName: CompanysService
 * @Description: TODO
 * @Author: ZS
 * @CreateName: lws
 * @Date 2022/3/8 13:39
 * ...
 */
public interface CompanyService {

    /**
     * 公安查询
     * @param req 查询条件
     * @return 返回结果
     */
    List<SelectCompanyPageResp> page(SelectCompanyPageReq req);
    /*
    * 获取所有的地铁列表
    * */
    List<CompanyVO> getCompanyList();
    /*
     * 获取所有的地区列表
     * */
    List<BranchVO> getBranchList(String companyId);

    /*
     * @创建者  WXG
     * @描述  抽取Company数据通过companyId
     * @时间  2022/5/9 12:49
     **/
    <T> Map<String, Company> getCompanyMapByList(List<T> list , Function<T,String> function);
    /*
     * @创建者  WXG
     * @描述  抽取Company数据通过BranchId
     * @时间  2022/5/9 12:49
     **/
    <T> Map<String, Company> getBranchMapByList(List<T> list , Function<T,String> function);
    /*
     * @创建者  WXG
     * @描述  地址使用广州李工的地址库
     * @时间  2022/7/19 11:21
     * @参数
     **/
    List<CompanyCompanyVO> getAll();
}
