package com.metro.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.ObjectUtil;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.metro.baseRe.BaseResponse;
import com.metro.entity.po.Area;
import com.metro.entity.ro.area.SelectAreaReq;
import com.metro.entity.ro.area.SelectAreaResp;
import com.metro.mapper.AreaMapper;
import com.metro.service.AreaService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.util.CollectionUtils;

import java.util.List;
import java.util.stream.Collectors;

/**
 * @ClassName: AreaServiceImpl
 * @Description: TODO
 * @Author: ZS
 * @CreateName: lws
 * @Date 2022/3/10 23:31
 * ...
 */
@Service
public class AreaServiceImpl implements AreaService {

    @Autowired
    private AreaMapper areaMapper;

    /**
     * 查询地区联动
     * @param req 查询条件
     * @return 返回结果list
     */
    @Override
    public BaseResponse<List<SelectAreaResp>> selectArea(SelectAreaReq req) {
        List<Area> areaList = areaMapper.selectList(selectAreaWrapper(req));
        if (CollectionUtils.isEmpty(areaList)) return BaseResponse.ok(null);
        return BaseResponse.ok(areaList.stream().map(p -> BeanUtil.toBean(p,SelectAreaResp.class)).collect(Collectors.toList()));
    }

    //查询地区联动 warpper
    private Wrapper<Area> selectAreaWrapper(SelectAreaReq req) {
        LambdaQueryWrapper<Area> wrapper= new LambdaQueryWrapper<>();
        wrapper.eq(ObjectUtil.isNotNull(req.getPid()),Area::getPid,req.getPid());
        return wrapper;
    }

}
