package com.metro.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.metro.baseRe.BaseResponse;
import com.metro.entity.po.DataDictionary;
import com.metro.entity.vo.DataDictionaryVO;
import com.metro.enums.DataDictionaryEnums;
import com.metro.mapper.DataDictionaryMapper;
import com.metro.service.DataDictionaryService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;
import java.util.stream.Collectors;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author wxg
 * @since 2022-07-21
 */
@Service
public class DataDictionaryServiceImpl implements DataDictionaryService {

    @Resource
    private DataDictionaryMapper dataDictionaryMapper;

    @Override
    public BaseResponse<List<DataDictionaryVO>> getOrgNameLsit() {
        DataDictionary dataDictionary = dataDictionaryMapper.selectOne(new LambdaQueryWrapper<>(DataDictionary.class).eq(DataDictionary::getIKey, DataDictionaryEnums.ORG_NAME.getKey()));
        List<DataDictionary> dataDictionaries = dataDictionaryMapper.selectList(new LambdaQueryWrapper<>(DataDictionary.class).eq(DataDictionary::getParentId, dataDictionary.getId()));
        List<DataDictionaryVO> projectResponseList = dataDictionaries.stream().map((entity) -> {
            DataDictionaryVO vo = new DataDictionaryVO();
            vo.setId(entity.getId());
            vo.setDataName(entity.getDataName());
            return vo;
        }).collect(Collectors.toList());
        return BaseResponse.ok(projectResponseList);
    }
}
