package com.metro.service.impl;


import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.metro.entity.dto.ExecuteControlDTO;
import com.metro.entity.po.ExecuteControl;
import com.metro.entity.search.ExecuteControlSearch;
import com.metro.entity.vo.ExecuteControlVO;
import com.metro.exception.BusinessException;
import com.metro.mapper.ExecuteControlMapper;
import com.metro.service.ExecuteControlService;
import com.metro.utils.StringUtils;
import org.springframework.beans.BeanUtils;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;

/**
 * <p>
 * 临时布控 服务实现类
 * </p>
 *
 * @author wxg
 * @since 2022-07-19
 */
@Service
public class ExecuteControlServiceImpl implements ExecuteControlService {

    @Resource
    private ExecuteControlMapper executeControlMapper;
    
    @Override
    public IPage<ExecuteControlVO> getPageList(ExecuteControlSearch executeControlSearch) {
        Page<ExecuteControl> page = new Page<>(executeControlSearch.getPageNum(),executeControlSearch.getPageSize());
        IPage<ExecuteControlVO> pageList = executeControlMapper.getPageList(page, executeControlSearch);
        if(pageList.getRecords().size() == 0) return new Page<>();
        return pageList;
    }
    @Override
    public Integer insertOrUpdate(ExecuteControlDTO executeControlDTO) {
        if(StringUtils.isEmpty(executeControlDTO.getIdNum())){
            throw new BusinessException("身份证号不能为空！");
        }
        ExecuteControl executeControl = executeControlMapper.selectBYIdNum(executeControlDTO.getIdNum());
        if(executeControl == null){
            executeControl = new ExecuteControl();
            BeanUtils.copyProperties(executeControlDTO,executeControl);
            return executeControlMapper.insertIn(executeControl);
        }else {
            BeanUtils.copyProperties(executeControlDTO,executeControl);
            return executeControlMapper.updateBykey(executeControl);
        }
    }

    @Override
    public Integer delete(String idNum) {
        return executeControlMapper.deleteById(idNum);
    }
}
