package com.metro.service.job;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.collection.CollectionUtil;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.metro.entity.po.DataShow;
import com.metro.mapper.CompanysMapper;
import com.metro.mapper.DataShowMapper;
import com.metro.mapper.PassreCordsMapper;
import com.metro.utils.DateUtils;
import com.metro.utils.StringUtils;
import lombok.extern.slf4j.Slf4j;
import org.springframework.context.annotation.Configuration;
import org.springframework.context.annotation.Lazy;
import org.springframework.scheduling.annotation.Async;
import org.springframework.scheduling.annotation.EnableAsync;
import org.springframework.scheduling.annotation.EnableScheduling;
import org.springframework.scheduling.annotation.Scheduled;

import javax.annotation.Resource;
import java.util.Calendar;
import java.util.Date;
import java.util.List;

/**
 * @description:
 * @ClassName AdminDataShowTask
 * @Author WXG
 * @Date 2021/11/12 20:52
 */
@Configuration      //1.主要用于标记配置类，兼备Component的效果。
@EnableScheduling   // 2.开启定时任务
@EnableAsync
@Slf4j
public class AdminDataShowTodayTask {

    @Resource
    @Lazy
    private PassreCordsMapper passreCordsMapper;
    @Resource
    @Lazy
    private DataShowMapper dataShowMapper;
    @Lazy
    @Resource
    private CompanysMapper companysMapper;
    /*
    *
    * */
    @Scheduled(fixedRate = 600000,zone = "Asia/Shanghai" ,initialDelay=120000)
    @Async
    public void dailyDataStatistics() {
        log.info("----------开始------每日10分钟数据统计-------------");

        Date date = DateUtils.addHours(new Date(), -12);
        Calendar calendar = Calendar.getInstance();
        calendar.setTime(date);
        calendar.set(Calendar.MINUTE, 0);
        calendar.set(Calendar.SECOND, 0);
        String passTime = DateUtils.parseDateToStr("yyyy-MM-dd HH:mm:ss", calendar.getTime());

        List<DataShow> list = dataShowMapper.updateData(passTime);
        if(CollectionUtil.isNotEmpty(list)){
            for (DataShow dataShow : list) {
                this.DataShowEdit(dataShow);
            }
        }

        /*查询出所有站点*/
//        List<Company> companyList = companysMapper.selectList(new LambdaQueryWrapper<Company>().isNotNull(Company::getBranchId));
//        companyList = companyList.stream().filter(p -> StringUtils.isNotEmpty(p.getCompanyId()) && StringUtils.isNotEmpty(p.getBranchId())).collect(Collectors.toList());
//        for (Company company : companyList) {
//            List<PassreCordsLessVO> passreCordsLessVOS = passreCordsMapper.selectTodayDataNumber(company.getCompanyId(), company.getBranchId());
//            if(CollectionUtil.isNotEmpty(passreCordsLessVOS)){
//
//            }
//            /*2.获取数据库中，今日0点之后的数据*/
//            Integer todayNumber = 0;//今日盘查人数
//            Integer todayExceptionNumber = 0;//今日异常人数
//            Integer todayDoubtNumber = 0;//今日存疑人数
//            Integer todayArrestNumber = 0;//今日抓捕人数
//            todayNumber = passreCordsLessVOS.stream().mapToInt(PassreCordsLessVO::getNumber).sum();
//            todayDoubtNumber = passreCordsLessVOS.stream().filter(p -> p.getPass() == 1 /*|| p.getPass() == 3*/).mapToInt(PassreCordsLessVO::getNumber).sum();
//            todayArrestNumber = passreCordsLessVOS.stream().filter(p -> p.getPass() == 0).mapToInt(PassreCordsLessVO::getNumber).sum();
//            todayExceptionNumber = passreCordsLessVOS.stream().filter(p -> p.getPass() == 3).mapToInt(PassreCordsLessVO::getNumber).sum();
//
//            DataShow dataShow5 = selectByCompanyIdAndType(company, DataShowTopEnum.TODAY_NUMBER.getType());
//            DataShow dataShow6 = selectByCompanyIdAndType(company, DataShowTopEnum.TODAY_EXCEPTION_NUMBER.getType());
//            DataShow dataShow7 = selectByCompanyIdAndType(company, DataShowTopEnum.TODAY_DOUBT_NUMBER.getType());
//            DataShow dataShow8 = selectByCompanyIdAndType(company, DataShowTopEnum.TODAY_ARREST_NUMBER.getType());
//
//            DataShowEdit(dataShow5,DataShowTopEnum.TODAY_NUMBER.getType(),todayNumber,company);
//            DataShowEdit(dataShow6,DataShowTopEnum.TODAY_EXCEPTION_NUMBER.getType(),todayExceptionNumber,company);
//            DataShowEdit(dataShow7,DataShowTopEnum.TODAY_DOUBT_NUMBER.getType(),todayDoubtNumber,company);
//            DataShowEdit(dataShow8,DataShowTopEnum.TODAY_ARREST_NUMBER.getType(),todayArrestNumber,company);
//        }
        log.info("----------完成------每日10分钟数据统计-------------");
    }
//    private DataShow selectByCompanyIdAndType(Company company, Integer type){
//        LambdaQueryWrapper<DataShow> dataShow = new LambdaQueryWrapper<>();
//        dataShow.eq(DataShow::getType, type);
//        dataShow.eq(StringUtils.isNotNull(company.getCompanyId()),DataShow::getCompanyId, company.getCompanyId());
//        dataShow.eq(StringUtils.isNotNull(company.getBranchId()),DataShow::getBranchId, company.getBranchId());
//        return dataShowMapper.selectOne(dataShow);
//    }
    private void DataShowEdit(DataShow dataShow){
        LambdaQueryWrapper<DataShow> lambdaQueryWrapper = new LambdaQueryWrapper<>();
        lambdaQueryWrapper.eq(StringUtils.isNotNull(dataShow.getCompanyId()),DataShow::getCompanyId, dataShow.getCompanyId());
        lambdaQueryWrapper.eq(StringUtils.isNotNull(dataShow.getBranchId()),DataShow::getBranchId, dataShow.getBranchId());
        lambdaQueryWrapper.eq(StringUtils.isNotNull(dataShow.getDate()),DataShow::getDate, dataShow.getDate());
        DataShow dataShow1 = dataShowMapper.selectOne(lambdaQueryWrapper);
        if(dataShow1 != null){
            dataShow1.setNumber(dataShow.getNumber());
            dataShow1.setArrestNumber(dataShow.getArrestNumber());
            dataShow1.setDoubtNumber(dataShow.getDoubtNumber());
            dataShow1.setPassNumber(dataShow.getPassNumber());
            dataShow1.setExceptionNumber(dataShow.getExceptionNumber());
            dataShowMapper.updateById(dataShow1);
        }else {
            dataShowMapper.insert(dataShow);
        }
    }
}
