package com.metro.service.job;

import lombok.extern.slf4j.Slf4j;
import org.springframework.context.annotation.Configuration;
import org.springframework.scheduling.annotation.EnableAsync;
import org.springframework.scheduling.annotation.EnableScheduling;

import javax.annotation.PostConstruct;
import javax.annotation.Resource;

/**
 * @description:
 * @ClassName AsyncTask
 * @Author WXG
 * @Date 2022/9/14 14:49
 */
@Configuration      //1.主要用于标记配置类，兼备Component的效果。
@EnableScheduling   // 2.开启定时任务
@EnableAsync
@Slf4j
public class AsyncTask {
    @Resource
    private AdminDataShowTask adminDataShowTask;
    @Resource
    private WarFruitTask warFruitTask;
    @PostConstruct
    private void start(){
        adminDataShowTask.dailyDataStatistics();//每日数据统计
        warFruitTask.dailyDataStatistics();//民警每日数据统计
    }
}
