package com.metro.service.job;

import com.metro.mapper.JPersonsMapper;
import lombok.extern.slf4j.Slf4j;
import org.springframework.context.annotation.Configuration;
import org.springframework.context.annotation.Lazy;
import org.springframework.scheduling.annotation.Async;
import org.springframework.scheduling.annotation.EnableAsync;
import org.springframework.scheduling.annotation.EnableScheduling;

import javax.annotation.PostConstruct;
import javax.annotation.Resource;

/**
 * @description:
 * @ClassName AdminDataShowTask
 * @Author WXG
 * @Date 2021/11/12 20:52
 */
@Configuration      //1.主要用于标记配置类，兼备Component的效果。
@EnableScheduling   // 2.开启定时任务
@EnableAsync
@Slf4j
public class JperSonTask {

    @Resource
    @Lazy
    private JPersonsMapper jPersonsMapper;
    /*
    * 因为地铁盘查生产的admin的companyId和branchId是null
    * */
    @PostConstruct
    @Async
    public void dailyDataStatistics() {
        log.info("----------开始------jPersons数据初始化-------------");
        jPersonsMapper.updateJperson();
        jPersonsMapper.updateJperson1();
        log.info("----------完成------jPersons数据初始化-------------");
    }
}
