package com.metro.service.job;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.metro.mapper.PassreCordsMapper;
import com.metro.mapper.WarFruitMapper;
import lombok.extern.slf4j.Slf4j;
import org.springframework.context.annotation.Configuration;
import org.springframework.context.annotation.DependsOn;
import org.springframework.scheduling.annotation.Async;
import org.springframework.scheduling.annotation.EnableAsync;
import org.springframework.scheduling.annotation.EnableScheduling;

import javax.annotation.Resource;

/**
 * @description:
 * @ClassName AdminDataShowTask
 * @Author WXG
 * @Date 2021/11/12 20:52
 */
@Configuration      //1.主要用于标记配置类，兼备Component的效果。
@EnableScheduling   // 2.开启定时任务
@EnableAsync
@Slf4j
@DependsOn("jperSonTask")
public class WarFruitTask {

    @Resource
    private PassreCordsMapper passreCordsMapper;
    @Resource
    private WarFruitMapper warFruitMapper;
    @Async
    public void dailyDataStatistics() {
        log.info("查询warFruit是否需要数据的数据初始化操作");
        Integer count = warFruitMapper.selectCount(new LambdaQueryWrapper<>());
        if(count != null && count >0){
            log.info("warFruit不需要初始化");
            return;
        }
        log.info("----------开始------民警每日数据统计-------------");
        warFruitMapper.initData();//数据初始化

//        /*1.查看战果统计中是否含有数据*/
//        List<NewPassreCordsWarFruitVO> list = passreCordsMapper.getWarFruitNew(1);
//
//        for (NewPassreCordsWarFruitVO vo : list) {
//            this.warFruitEdit(vo);
//        }
        log.info("----------完成------民警每日数据统计-------------");
    }

//    private void warFruitEdit(NewPassreCordsWarFruitVO vo){
//        LambdaQueryWrapper<WarFruit> warFruitWrapper = new LambdaQueryWrapper<>();
//        warFruitWrapper.eq(WarFruit::getCardId,vo.getCardId());
//        warFruitWrapper.eq(WarFruit::getDate,vo.getDate());
//        WarFruit warFruit = warFruitMapper.selectOne(warFruitWrapper);
//        int type = 0;// 1-insert 0=update
//        if(warFruit == null){
//            warFruit = new WarFruit();
//            type = 1;
//        }
//        Integer arrestNumber = vo.getArrestNumber() == null? 0 : vo.getArrestNumber();
//        Integer doubtNumber = vo.getDoubtNumber() == null? 0 : vo.getDoubtNumber();
//        Integer passNumber = vo.getPassNumber() == null? 0 : vo.getPassNumber();
//        Integer exceptionNumber = vo.getExceptionNumber() == null? 0 : vo.getExceptionNumber();
//        warFruit.setCardId(vo.getCardId());
//        warFruit.setDate(vo.getDate());
//        warFruit.setArrestNumber(arrestNumber);
//        warFruit.setDoubtNumber(doubtNumber);
//        warFruit.setPassNumber(passNumber);
//        warFruit.setExceptionNumber(exceptionNumber);
//        warFruit.setNumber(arrestNumber + doubtNumber + passNumber + exceptionNumber);
//        if(type == 1 ){
//            warFruitMapper.insert(warFruit);
//        }else {
//            warFruitMapper.updateById(warFruit);
//        }
//    }
}
